Loading...
Searching...
No Matches
Dune::Amg::Hierarchy< T, A > Class Template Reference
Iterative Solvers Template Library (ISTL) » Iterative Solvers » Preconditioners » Parallel Algebraic Multigrid

A hierarchy of containers (e.g. matrices or vectors). More...

`#include <dune/istl/paamg/hierarchy.hh>`

Inheritance diagram for Dune::Amg::Hierarchy< T, A >:

## Classes

class | LevelIterator
| Iterator over the levels in the hierarchy. More...

## Public Types

typedef T | MemberType
| The type of the container we store.
using | Allocator = typename std::allocator_traits<A>::template rebind_alloc<Element>
| The allocator to use for the list elements.
typedef ConstructionTraits< T >::Arguments | Arguments
typedef LevelIterator< Hierarchy< T, A >, T > | Iterator
| Type of the mutable iterator.
typedef LevelIterator< const Hierarchy< T, A >, const T > | ConstIterator
| Type of the const iterator.

## Public Member Functions

| Hierarchy (const std::shared_ptr< MemberType > &first)
| Construct a new hierarchy.
| Hierarchy ()
| Construct an empty hierarchy.
| Hierarchy (const Hierarchy &other)
| Copy constructor (deep copy!).
void | addCoarser (Arguments &args)
| Add an element on a coarser level.
void | addRedistributedOnCoarsest (Arguments &args)
void | addFiner (Arguments &args)
| Add an element on a finer level.
Iterator | finest ()
| Get an iterator positioned at the finest level.
Iterator | coarsest ()
| Get an iterator positioned at the coarsest level.
ConstIterator | finest () const
| Get an iterator positioned at the finest level.
ConstIterator | coarsest () const
| Get an iterator positioned at the coarsest level.
std::size_t | levels () const
| Get the number of levels in the hierarchy.

## Detailed Description

template<typename T, typename A = std::allocator<T>>
class Dune::Amg::Hierarchy< T, A >

A hierarchy of containers (e.g. matrices or vectors).

Because sometimes a redistribution of the parallel data might be advisable one can add redistributed version of the container at each level.

## Member Typedef Documentation

## Allocator

template<typename T, typename A = std::allocator<T>>

using Dune::Amg::Hierarchy< T, A >::Allocator = typename std::allocator_traits<A>::template rebind_alloc<Element>

The allocator to use for the list elements.

## Arguments

template<typename T, typename A = std::allocator<T>>

typedef ConstructionTraits<T>::Arguments Dune::Amg::Hierarchy< T, A >::Arguments

## ConstIterator

template<typename T, typename A = std::allocator<T>>

typedef LevelIterator<const Hierarchy<T,A>, const T> Dune::Amg::Hierarchy< T, A >::ConstIterator

Type of the const iterator.

## Iterator

template<typename T, typename A = std::allocator<T>>

typedef LevelIterator<Hierarchy<T,A>,T> Dune::Amg::Hierarchy< T, A >::Iterator

Type of the mutable iterator.

## MemberType

template<typename T, typename A = std::allocator<T>>

typedef T Dune::Amg::Hierarchy< T, A >::MemberType

The type of the container we store.

## Constructor & Destructor Documentation

## Hierarchy()

template<typename T, typename A = std::allocator<T>>

Dune::Amg::Hierarchy< T, A >::Hierarchy | ( |  | ) |

inline

Construct an empty hierarchy.

The documentation for this class was generated from the following file:

- hierarchy.hh